// Heatbugs application. Copyright  1996-2000 Swarm Development Group.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// The HeatbugBatchSwarm is an alternative to the HeatbugObserverSwarm
// It's also a toplevel swarm that directs execution of a model, but it
// operates without any graphics - just does file I/O to store data.

#import <objectbase.h>
#import "ModelSwarm.h"
#import <analysis.h> // EZGraph

@interface BatchSwarm: Swarm
{
  int loggingFrequency;	       		  // Frequency of fileI/O
  int logIn;	       		  // Frequency of fileI/O
  int generations;
  int experimentDuration;
  id displayActions;			  // schedule data structs
  id displaySchedule;
  id stopSchedule;

  ModelSwarm *modelSwarm;	  // the Swarm we're observing

             
  id game;   
  id groups; 

  id <EZGraph> aGraph;
  id <EZGraph> bGraph;
             
}

+ createBegin: aZone;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- go;

// special message on ourselves to stop running.
- stopRunning;

@end
