// Genesis.m
//--------------------------------------------------------------------

#import "Groups.h"


@implementation Groups

- setNumberOfGroups: (int)o
{

  numberOfGroups=o;

  return self;
}



- setFunction: (SEL)a ;
{

  selectFunction=a;
  return self;
}

- setPopulation: p
{
  population=p;
  return self;

}

- setName: (char *) n group: (int)g
{
   id index;
   index=[names begin: [self getZone]];
   [index setOffset: g];
   [index put:(id)n];
   [index drop];
  return self;
 



}

//====================================================================
//  Part 2 - createEnd
//====================================================================

//--------------------------------------------------------------------
//Here we build lists to handle evolution and set to zero statistics
//counters

- createEnd
{
  int i;

   id obj;
   groups=[List create: [self getZone]];
   names=[List create: [self getZone]];
   for (i=0; i<numberOfGroups;i++) {
     id list;
     list=[List create: [self getZone]];
     [groups addLast: list];
     [names addLast: (id) "N/A"];
   }   

   obj = [super createEnd];
   return obj;

}


-step;
{
  [self fillGroups];
  return self;
}

//------------------------------------------------------

- fillGroups;
{
  id index;
  id aGuy;
  int i;

[groups forEach: M(removeAll)];

index=[population begin: [self getZone]];
while ((aGuy=[index next])) {
 i=(int)[aGuy perform: selectFunction];
 [[groups atOffset:i] addLast:aGuy];
   }
 [index drop];
 return self;
}



- printGroups;
{
  id index;
  id list;

index=[groups begin: [self getZone]];
while ((list=[index next])) {
  if (file)   fprintf(file,"%d\t",[list getCount]);
   else   printf("%d\t",[list getCount]);
  }
  [index drop];
  if (file)   fprintf(file,"\n");
   else   printf("\n");


    return self;
  }


- printByGroup;
{
  id index;
  id list;


index=[groups begin: [self getZone]];

while ((list=[index next])) {
 [list forEach: M(print)];
 printf("\n");
  }
  [index drop];
 printf("\n");
    return self;
  }


-toFile:(char *)f {

 file=fopen(f,"w");
 return self;
}

- (unsigned) getCount {
  return numberOfGroups;
}


-  getGroup: (int)g {

  return [groups atOffset:g];

 }

- (char *)getName: (int)g {
  char *q;

    q=(char *)[names atOffset:g];

  return q;
}

-(void)drop {
  if (file) fclose(file);
  [super drop];
}
//--------------------------------------------------------------------
@end
