// Hello, World! application. Copyright  1996-2000 Swarm Development Group.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// This is the header file for the Person agent.  It defines the 
// instance variables and everything else the Person needs to work
// in the world.
#import <objectbase/SwarmObject.h>
#import  <simtools/NSelect.h>



// Person.m
@interface Person: SwarmObject
{
  id population;
  id model;
  id game;
  int typology;
  int value;
  int strategy;
  float payoff;
  float fitness;
  int action;
}


//---------------- setting facilities ------------------//


// set the environment up so that the agent can receive sensory input
- setWorld: l Model: m G: g;

- reset;


- setPerson: (int)ww strategy: (int )o; 



- setPayoff: (float )o;


- setFitness: (float) o;

// customized createEnd to instantiate any special variables
- createEnd;


//----------- end of setting ----------------//

//------------- getting stuff from it ----------------//

- (float) getFitness; 



- (int) getStrategy;

- (int) getAction;



- (int) getTypology;

- (int) getProfile;

//------------- no more getting ------------//


// ---------------using -------------------//


// move one time step forward
- step;

- addFitness;

// look around for someone to talk to
- look;

// decide to stay or go
-  play: (Person *) tgt;

- upDate;

- mutate;


- copy: aZone;



// print info about the person
- print;


@end
