// Hello, World! application. Copyright  1996-2000 Swarm Development Group.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// This is the method definitions file for the Person agents.

// include person header so that everything will be defined
#import "Person.h"
#import "ModelSwarm.h"
#import "Macro.h"
#import <collections.h>
#import <random.h>
#import <analysis.h>

@implementation Person

- step
{


  id group=[List create: [self getZone]];
  id graph;
  // Here is the call to the EZDistribution, which is returned by [model getCalc]

    [NSelect select: 10 from: population into: group];
    graph=[model getCalc];
    [graph  update];
    [group drop];

    // end EZDistribution call

  [self play:  [self look]];

  return self;
}


//-------------- setting stuff ----------------//

- setWorld: l Model: m G: g;
{
  population = l;   // set a pointer to the list where it belogs
  model=m; //set a pointer to the swarm model
  game=g;
  return self;
}

- reset
{
  fitness=0;
  payoff=0;
  value=0;

   return self;
}

- setPerson: (int)ww strategy: (int )o 
{
 
  typology = ww;
  value = 0;
  strategy=o;
  return self;
}


- setPayoff: (float ) o
   { 

     payoff=o;
     [self addFitness];
     return self;
}


- setFitness: (float) o;
{
  fitness=o;
  return self;
}


- createEnd
{

  [super createEnd];
  return self;
}


//------------- getting stuff from it---------------//

- (float) getFitness;
{ 
  return fitness/value;
     }



- (int) getStrategy
{
  return strategy;
}


- (int) getProfile 
{

  return strategy;

  

}

- (int) getAction 
{

  return action;

  

}


-(int) getTypology {
  return typology;
}

//------------end of getting -------------//


- addFitness;
{
  value++;  
fitness+=payoff;
  return self;
}


- (Person *)look
{
  id tgt;

  while (self==(tgt = [population atOffset: [uniformIntRand getIntegerWithMin: 0L  withMax: ([population getCount] - 1)]]));
  return tgt;
}


- (int) action: (Person *) tgt
{




  switch (strategy) {  case 0:
    action=typology;
    break;
  case 1:
 
  
  action=typology;;

    break;

  default: error("strategy $d not defined\n",strategy);
   }
  return action;
}


-  play: (Person *) tgt
{ 
  int myA, oA;
  myA=[self action: tgt];
  oA=[tgt action: self];
  [self setPayoff: [game Pay: myA other: oA]];
  [tgt setPayoff: [game Pay: oA other: myA]];
  

 return self;
 }

-upDate
{

  return self;
}

- mutate 
{
 strategy=ranint(0,1);
 
 return self;
}



- copy: aZone
{
  Person *new;
  new=[Person create: aZone];
  new=[aZone copyIVars: self];
  return new;
  
  
}


- print
{


  (void)printf("%d%s%d%s%f\n",typology,
		"\tstrategy = ", strategy,
                 "\tfitness = ",[self getFitness]);

  return self;
}

@end
